(function() {
    //check version
    var thisVer = chrome.runtime.getManifest().version;
    var baseURL = chrome.runtime.getManifest().homepage_url;
    $.get(baseURL + '/check-crx-version.php',function (data) {
        if(thisVer!=data){
            confirm("AxurePRD Chrome "+data+" 已发布，请及时更新\n>>>点击“确定”去官网下载") && window.open(baseURL+"/#download");
        }
    });

    // 监听来自content-script的消息
    chrome.runtime.onMessage.addListener(function(msg, sender, sendResponse)
    {
        // console.log('axp receive：');
        // console.log(msg, sender, sendResponse);

        if(msg.axplusTag){
            if(msg.script){
                eval(msg.script);
                // console.log('axp bg exec：'+msg.script);
            }
            var img = $("<img/>").appendTo('body')[0];
            img.onload = function(){
                var rgb = '#0099ff';
                try{
                    var canvas = document.createElement('canvas');
                    canvas.width = 1;
                    canvas.height = 1;
                    var ctx = canvas.getContext('2d');
                    ctx.drawImage(img, parseInt(img.width / 2), parseInt(img.height / 2), 1, 1, 0, 0, 1, 1);
                    var centerPoint = ctx.getImageData(0, 0, 1, 1).data;
                    if(centerPoint[3]==255){
                        rgb = '#' + hex(centerPoint[0]) + hex(centerPoint[1]) + hex(centerPoint[2]);
                    }else{
                        canvas.width = img.width;
                        canvas.height = img.height;
                        var ctx = canvas.getContext('2d');
                        ctx.drawImage(img, 0, 0);
                        var imgDataFlow = ctx.getImageData(0, 0, canvas.width, canvas.height).data;
                        for (var i=0;i<imgDataFlow.length;i+=4){
                            if(imgDataFlow[i+3]==255){
                                rgb = '#' + hex(imgDataFlow[i]) + hex(imgDataFlow[i+1]) + hex(imgDataFlow[i+2]);
                                break;
                            }
                        }
                    }
                    var imgmap = {};
                    imgmap[msg.imgsrc] = rgb;
                    sendMessageToContentScript({axplusTag:msg.axplusTag,imgcolor:imgmap}, function(response){
                        // console.log('axp from content：'+response);
                    });
                }catch(e){}
            }
            img.src = msg.imgsrc;
        }
        sendResponse('axp bg received：' + JSON.stringify(msg));
        return true;
    });
    function hex(x) {
        return ("0" + parseInt(x).toString(16)).slice(-2);
    }
    function sendMessageToContentScript(msg, callback)
    {
        if(!msg.axplusTag){
            msg.axplusTag = "axplusTag"+Math.random()+new Date().getTime();
        }
        chrome.tabs.query({active: true, currentWindow: true}, function(tabs)
        {
            chrome.tabs.sendMessage(tabs[0].id, msg, function(response)
            {
                if(callback) callback(response);
            });
        });
    }
    // 获取当前选项卡ID
    function getCurrentTabId(callback)
    {
        chrome.tabs.query({active: true, currentWindow: true}, function(tabs)
        {
            if(callback) callback(tabs.length ? tabs[0].id: null);
        });
    }
})();